#ifndef _mesh_
#define _mesh_

#include <vector>
#include "domain.h"


class mesh : public vector < domain >
{
public :
  // Constructor
  mesh() { };
  mesh( domain initial, int nombre );

  void out();

  // renvoie l'indice du domain pointé par point
  int which_one( domain point);
  
  // test si deux domaines s'intersectent
  bool voisin(int,int);

  // enveloppe interval 
  domain wrapping(vector < int >);

  // create a mesh which is the boundary (*this)
  mesh boundary();

  domain initial;
  vector < domain > initial_boundary;


 private :
  int nombre;
  mesh(domain) ;
  void myinsert(mesh);
  mesh cut(string direction, int nombre);

};

#endif
 
