#include <vector>
#include <list>
#include "sivia.h"


//---------------------------------------------------------------------
sivia::sivia (Map the_map , domain y1)
{
  f = the_map; 
  y = y1;
}

//---------------------------------------------------------------------
iboolean sivia::Inside(domain x)
{   
  if (f.evalue(x).subset(y)) return itrue;
  if (f.evalue(x).disjoint(y)) return ifalse;
  return iperhaps;
};

//---------------------------------------------------------------------
int sivia::SIVIAfile(domain P, double epsilon)
{
    int k=0;

    list <domain> L_cur;
    L_cur.clear();

    L_sivia_IN.clear();
    L_sivia_OUT.clear();
    L_sivia_MB.clear();

// on place P dans la list L par le bas
    L_cur.push_back(P);
    int count_les_jaunes = 0;
    while (!L_cur.empty())
// on prend le premier element de la liste sur le dessus et on le nomme P
    {
      P=L_cur.front();
      L_cur.pop_front();
      iboolean test= Inside(P);
      if (P.width() < epsilon)
	{
	  if (test==itrue) L_sivia_IN.push_back(P);
	  else if (test==ifalse) L_sivia_OUT.push_back(P);
	  else {L_sivia_MB.push_back(P); k++; }
	}
      else if (test==itrue)  { L_sivia_IN.push_back(P); }
      else if (test==ifalse) { L_sivia_OUT.push_back(P); }
      else  {
	mesh M(P,2);
	for (mesh::const_iterator i = M.begin(); i!=M.end();++i)
	  {
	    L_cur.push_back(*i);
	  }
      }
    }
    return k;
} ;

