#include "taylor.h"


taylor::taylor(domain x)
{

   for (map<string,interval>::const_iterator i = x.begin(); i!=x.end(); ++i)
    { 
      (*this)[i->first].push_back(i->second);
    }
  
}


domain taylor::evaluate(interval t)
{
  domain result;
  for (taylor::const_iterator i = (*this).begin(); i!=(*this).end(); ++i)
    { 
      result[i->first] = interval(0,0);
      for (int j = 0 ; j< (i->second).size(); j++)
	{ 
	  /*	  cout << result[i->first] << endl;
	  cout << result[i->first].hexImage(cout) << endl;
	  cout << "------------------" << endl;*/
	  result[i->first] = result[i->first]  + i->second[j]*(power(t,j)); 
	}  
    }
  return result;
}


void taylor::out()
{

  for (taylor::const_iterator i = (*this).begin(); i!=(*this).end(); ++i)
    { 
      cout << "" << endl;
      cout << i->first << ": "<< endl;
      for (int j = 0 ; j< (i->second).size(); j++)
	{ 
	  cout << j <<  ":" << i->second[j]<< ","; 
	}
      
    }
      cout <<  "" << endl;

}


